unit GFSProxyJson;

interface

uses
  OpenApiJson, 
  GFSProxyDtos;

type
  TJsonConverter = class;
  
  TJsonConverter = class(TCustomJsonConverter)
  public
    function TLabelSpecificationToJsonValue(Source: TLabelSpecification): TJSONValue;
    function TLabelSpecificationToJson(Source: TLabelSpecification): string;
    function TLabelSpecificationFromJsonValue(Source: TJSONValue): TLabelSpecification;
    function TLabelSpecificationFromJson(Source: string): TLabelSpecification;
    function TConsignmentWeightToJsonValue(Source: TConsignmentWeight): TJSONValue;
    function TConsignmentWeightToJson(Source: TConsignmentWeight): string;
    function TConsignmentWeightFromJsonValue(Source: TJSONValue): TConsignmentWeight;
    function TConsignmentWeightFromJson(Source: string): TConsignmentWeight;
    function TConsignmentToJsonValue(Source: TConsignment): TJSONValue;
    function TConsignmentToJson(Source: TConsignment): string;
    function TConsignmentFromJsonValue(Source: TJSONValue): TConsignment;
    function TConsignmentFromJson(Source: string): TConsignment;
    function TPackageDimensionsToJsonValue(Source: TPackageDimensions): TJSONValue;
    function TPackageDimensionsToJson(Source: TPackageDimensions): string;
    function TPackageDimensionsFromJsonValue(Source: TJSONValue): TPackageDimensions;
    function TPackageDimensionsFromJson(Source: string): TPackageDimensions;
    function TPackageToJsonValue(Source: TPackage): TJSONValue;
    function TPackageToJson(Source: TPackage): string;
    function TPackageFromJsonValue(Source: TJSONValue): TPackage;
    function TPackageFromJson(Source: string): TPackage;
    function TPackageListToJsonValue(Source: TPackageList): TJSONValue;
    function TPackageListToJson(Source: TPackageList): string;
    function TPackageListFromJsonValue(Source: TJSONValue): TPackageList;
    function TPackageListFromJson(Source: string): TPackageList;
    function TCustomsDataCommoditiesItemValueToJsonValue(Source: TCustomsDataCommoditiesItemValue): TJSONValue;
    function TCustomsDataCommoditiesItemValueToJson(Source: TCustomsDataCommoditiesItemValue): string;
    function TCustomsDataCommoditiesItemValueFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItemValue;
    function TCustomsDataCommoditiesItemValueFromJson(Source: string): TCustomsDataCommoditiesItemValue;
    function TCustomsDataCommoditiesItemWeightToJsonValue(Source: TCustomsDataCommoditiesItemWeight): TJSONValue;
    function TCustomsDataCommoditiesItemWeightToJson(Source: TCustomsDataCommoditiesItemWeight): string;
    function TCustomsDataCommoditiesItemWeightFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItemWeight;
    function TCustomsDataCommoditiesItemWeightFromJson(Source: string): TCustomsDataCommoditiesItemWeight;
    function TCustomsDataCommoditiesItemToJsonValue(Source: TCustomsDataCommoditiesItem): TJSONValue;
    function TCustomsDataCommoditiesItemToJson(Source: TCustomsDataCommoditiesItem): string;
    function TCustomsDataCommoditiesItemFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItem;
    function TCustomsDataCommoditiesItemFromJson(Source: string): TCustomsDataCommoditiesItem;
    function TCustomsDataCommoditiesItemListToJsonValue(Source: TCustomsDataCommoditiesItemList): TJSONValue;
    function TCustomsDataCommoditiesItemListToJson(Source: TCustomsDataCommoditiesItemList): string;
    function TCustomsDataCommoditiesItemListFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItemList;
    function TCustomsDataCommoditiesItemListFromJson(Source: string): TCustomsDataCommoditiesItemList;
    function TCustomsDataToJsonValue(Source: TCustomsData): TJSONValue;
    function TCustomsDataToJson(Source: TCustomsData): string;
    function TCustomsDataFromJsonValue(Source: TJSONValue): TCustomsData;
    function TCustomsDataFromJson(Source: string): TCustomsData;
    function TAddressToJsonValue(Source: TAddress): TJSONValue;
    function TAddressToJson(Source: TAddress): string;
    function TAddressFromJsonValue(Source: TJSONValue): TAddress;
    function TAddressFromJson(Source: string): TAddress;
    function TServiceOptionsToJsonValue(Source: TServiceOptions): TJSONValue;
    function TServiceOptionsToJson(Source: TServiceOptions): string;
    function TServiceOptionsFromJsonValue(Source: TJSONValue): TServiceOptions;
    function TServiceOptionsFromJson(Source: string): TServiceOptions;
    function TCreateLabelRequestToJsonValue(Source: TCreateLabelRequest): TJSONValue;
    function TCreateLabelRequestToJson(Source: TCreateLabelRequest): string;
    function TCreateLabelRequestFromJsonValue(Source: TJSONValue): TCreateLabelRequest;
    function TCreateLabelRequestFromJson(Source: string): TCreateLabelRequest;
    function TCreateLabelResponsePackagesItemToJsonValue(Source: TCreateLabelResponsePackagesItem): TJSONValue;
    function TCreateLabelResponsePackagesItemToJson(Source: TCreateLabelResponsePackagesItem): string;
    function TCreateLabelResponsePackagesItemFromJsonValue(Source: TJSONValue): TCreateLabelResponsePackagesItem;
    function TCreateLabelResponsePackagesItemFromJson(Source: string): TCreateLabelResponsePackagesItem;
    function TCreateLabelResponsePackagesItemListToJsonValue(Source: TCreateLabelResponsePackagesItemList): TJSONValue;
    function TCreateLabelResponsePackagesItemListToJson(Source: TCreateLabelResponsePackagesItemList): string;
    function TCreateLabelResponsePackagesItemListFromJsonValue(Source: TJSONValue): TCreateLabelResponsePackagesItemList;
    function TCreateLabelResponsePackagesItemListFromJson(Source: string): TCreateLabelResponsePackagesItemList;
    function TCreateLabelResponseToJsonValue(Source: TCreateLabelResponse): TJSONValue;
    function TCreateLabelResponseToJson(Source: TCreateLabelResponse): string;
    function TCreateLabelResponseFromJsonValue(Source: TJSONValue): TCreateLabelResponse;
    function TCreateLabelResponseFromJson(Source: string): TCreateLabelResponse;
    function TErrorToJsonValue(Source: TError): TJSONValue;
    function TErrorToJson(Source: TError): string;
    function TErrorFromJsonValue(Source: TJSONValue): TError;
    function TErrorFromJson(Source: string): TError;
  end;
  
implementation

{ TJsonConverter }

function TJsonConverter.TLabelSpecificationToJsonValue(Source: TLabelSpecification): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'labelFormat', Self.stringToJsonValue(Source.LabelFormat));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TLabelSpecificationToJson(Source: TLabelSpecification): string;
var
  JValue: TJSONValue;
begin
  JValue := TLabelSpecificationToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TLabelSpecificationFromJsonValue(Source: TJSONValue): TLabelSpecification;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TLabelSpecification.Create;
  try
    if Json.ObjContains(Source, 'labelFormat', JValue) then
      Result.LabelFormat := Self.stringFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TLabelSpecificationFromJson(Source: string): TLabelSpecification;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TLabelSpecificationFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TConsignmentWeightToJsonValue(Source: TConsignmentWeight): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'unit', Self.stringToJsonValue(Source.&Unit));
    Json.ObjAddProp(Result, 'value', Self.DoubleToJsonValue(Source.Value));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TConsignmentWeightToJson(Source: TConsignmentWeight): string;
var
  JValue: TJSONValue;
begin
  JValue := TConsignmentWeightToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TConsignmentWeightFromJsonValue(Source: TJSONValue): TConsignmentWeight;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TConsignmentWeight.Create;
  try
    if Json.ObjContains(Source, 'unit', JValue) then
      Result.&Unit := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'value', JValue) then
      Result.Value := Self.DoubleFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TConsignmentWeightFromJson(Source: string): TConsignmentWeight;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TConsignmentWeightFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TConsignmentToJsonValue(Source: TConsignment): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'weight', Self.TConsignmentWeightToJsonValue(Source.Weight));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TConsignmentToJson(Source: TConsignment): string;
var
  JValue: TJSONValue;
begin
  JValue := TConsignmentToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TConsignmentFromJsonValue(Source: TJSONValue): TConsignment;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TConsignment.Create;
  try
    if Json.ObjContains(Source, 'weight', JValue) then
      Result.Weight := Self.TConsignmentWeightFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TConsignmentFromJson(Source: string): TConsignment;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TConsignmentFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TPackageDimensionsToJsonValue(Source: TPackageDimensions): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'length', Self.DoubleToJsonValue(Source.Length));
    Json.ObjAddProp(Result, 'width', Self.DoubleToJsonValue(Source.Width));
    Json.ObjAddProp(Result, 'height', Self.DoubleToJsonValue(Source.Height));
    Json.ObjAddProp(Result, 'unit', Self.stringToJsonValue(Source.&Unit));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TPackageDimensionsToJson(Source: TPackageDimensions): string;
var
  JValue: TJSONValue;
begin
  JValue := TPackageDimensionsToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TPackageDimensionsFromJsonValue(Source: TJSONValue): TPackageDimensions;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TPackageDimensions.Create;
  try
    if Json.ObjContains(Source, 'length', JValue) then
      Result.Length := Self.DoubleFromJsonValue(JValue);
    if Json.ObjContains(Source, 'width', JValue) then
      Result.Width := Self.DoubleFromJsonValue(JValue);
    if Json.ObjContains(Source, 'height', JValue) then
      Result.Height := Self.DoubleFromJsonValue(JValue);
    if Json.ObjContains(Source, 'unit', JValue) then
      Result.&Unit := Self.stringFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TPackageDimensionsFromJson(Source: string): TPackageDimensions;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TPackageDimensionsFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TPackageToJsonValue(Source: TPackage): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    if Source.DescriptionHasValue then
      Json.ObjAddProp(Result, 'description', Self.stringToJsonValue(Source.Description));
    if Source.InvoiceNumberHasValue then
      Json.ObjAddProp(Result, 'invoiceNumber', Self.stringToJsonValue(Source.InvoiceNumber));
    if Assigned(Source.Dimensions) then
      Json.ObjAddProp(Result, 'dimensions', Self.TPackageDimensionsToJsonValue(Source.Dimensions));
    Json.ObjAddProp(Result, 'packageClientReferenceId', Self.stringToJsonValue(Source.PackageClientReferenceId));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TPackageToJson(Source: TPackage): string;
var
  JValue: TJSONValue;
begin
  JValue := TPackageToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TPackageFromJsonValue(Source: TJSONValue): TPackage;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TPackage.Create;
  try
    if Json.ObjContains(Source, 'description', JValue) then
      Result.Description := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'invoiceNumber', JValue) then
      Result.InvoiceNumber := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'dimensions', JValue) then
      Result.Dimensions := Self.TPackageDimensionsFromJsonValue(JValue);
    if Json.ObjContains(Source, 'packageClientReferenceId', JValue) then
      Result.PackageClientReferenceId := Self.stringFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TPackageFromJson(Source: string): TPackage;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TPackageFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TPackageListToJsonValue(Source: TPackageList): TJSONValue;
var
  Index: Integer;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateArray;
  try
    for Index := 0 to Source.Count - 1 do
      Json.ArrayAdd(Result, Self.TPackageToJsonValue(Source[Index]));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TPackageListToJson(Source: TPackageList): string;
var
  JValue: TJSONValue;
begin
  JValue := TPackageListToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TPackageListFromJsonValue(Source: TJSONValue): TPackageList;
var
  Index: Integer;
begin
  if not Json.IsArray(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TPackageList.Create;
  try
    for Index := 0 to Json.ArrayLength(Source) - 1 do
      Result.Add(Self.TPackageFromJsonValue(Json.ArrayGet(Source, Index)));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TPackageListFromJson(Source: string): TPackageList;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TPackageListFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemValueToJsonValue(Source: TCustomsDataCommoditiesItemValue): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'currency', Self.stringToJsonValue(Source.Currency));
    Json.ObjAddProp(Result, 'value', Self.DoubleToJsonValue(Source.Value));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemValueToJson(Source: TCustomsDataCommoditiesItemValue): string;
var
  JValue: TJSONValue;
begin
  JValue := TCustomsDataCommoditiesItemValueToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemValueFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItemValue;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCustomsDataCommoditiesItemValue.Create;
  try
    if Json.ObjContains(Source, 'currency', JValue) then
      Result.Currency := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'value', JValue) then
      Result.Value := Self.DoubleFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemValueFromJson(Source: string): TCustomsDataCommoditiesItemValue;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCustomsDataCommoditiesItemValueFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemWeightToJsonValue(Source: TCustomsDataCommoditiesItemWeight): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'unit', Self.stringToJsonValue(Source.&Unit));
    Json.ObjAddProp(Result, 'value', Self.DoubleToJsonValue(Source.Value));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemWeightToJson(Source: TCustomsDataCommoditiesItemWeight): string;
var
  JValue: TJSONValue;
begin
  JValue := TCustomsDataCommoditiesItemWeightToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemWeightFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItemWeight;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCustomsDataCommoditiesItemWeight.Create;
  try
    if Json.ObjContains(Source, 'unit', JValue) then
      Result.&Unit := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'value', JValue) then
      Result.Value := Self.DoubleFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemWeightFromJson(Source: string): TCustomsDataCommoditiesItemWeight;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCustomsDataCommoditiesItemWeightFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemToJsonValue(Source: TCustomsDataCommoditiesItem): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'quantity', Self.IntegerToJsonValue(Source.Quantity));
    Json.ObjAddProp(Result, 'description', Self.stringToJsonValue(Source.Description));
    Json.ObjAddProp(Result, 'hsCode', Self.stringToJsonValue(Source.HsCode));
    Json.ObjAddProp(Result, 'value', Self.TCustomsDataCommoditiesItemValueToJsonValue(Source.Value));
    Json.ObjAddProp(Result, 'weight', Self.TCustomsDataCommoditiesItemWeightToJsonValue(Source.Weight));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemToJson(Source: TCustomsDataCommoditiesItem): string;
var
  JValue: TJSONValue;
begin
  JValue := TCustomsDataCommoditiesItemToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItem;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCustomsDataCommoditiesItem.Create;
  try
    if Json.ObjContains(Source, 'quantity', JValue) then
      Result.Quantity := Self.IntegerFromJsonValue(JValue);
    if Json.ObjContains(Source, 'description', JValue) then
      Result.Description := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'hsCode', JValue) then
      Result.HsCode := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'value', JValue) then
      Result.Value := Self.TCustomsDataCommoditiesItemValueFromJsonValue(JValue);
    if Json.ObjContains(Source, 'weight', JValue) then
      Result.Weight := Self.TCustomsDataCommoditiesItemWeightFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemFromJson(Source: string): TCustomsDataCommoditiesItem;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCustomsDataCommoditiesItemFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemListToJsonValue(Source: TCustomsDataCommoditiesItemList): TJSONValue;
var
  Index: Integer;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateArray;
  try
    for Index := 0 to Source.Count - 1 do
      Json.ArrayAdd(Result, Self.TCustomsDataCommoditiesItemToJsonValue(Source[Index]));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemListToJson(Source: TCustomsDataCommoditiesItemList): string;
var
  JValue: TJSONValue;
begin
  JValue := TCustomsDataCommoditiesItemListToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemListFromJsonValue(Source: TJSONValue): TCustomsDataCommoditiesItemList;
var
  Index: Integer;
begin
  if not Json.IsArray(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCustomsDataCommoditiesItemList.Create;
  try
    for Index := 0 to Json.ArrayLength(Source) - 1 do
      Result.Add(Self.TCustomsDataCommoditiesItemFromJsonValue(Json.ArrayGet(Source, Index)));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataCommoditiesItemListFromJson(Source: string): TCustomsDataCommoditiesItemList;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCustomsDataCommoditiesItemListFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataToJsonValue(Source: TCustomsData): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'commodities', Self.TCustomsDataCommoditiesItemListToJsonValue(Source.Commodities));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataToJson(Source: TCustomsData): string;
var
  JValue: TJSONValue;
begin
  JValue := TCustomsDataToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCustomsDataFromJsonValue(Source: TJSONValue): TCustomsData;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCustomsData.Create;
  try
    if Json.ObjContains(Source, 'commodities', JValue) then
      Result.Commodities := Self.TCustomsDataCommoditiesItemListFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCustomsDataFromJson(Source: string): TCustomsData;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCustomsDataFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TAddressToJsonValue(Source: TAddress): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'name', Self.stringToJsonValue(Source.Name));
    if Source.CompanyNameHasValue then
      Json.ObjAddProp(Result, 'companyName', Self.stringToJsonValue(Source.CompanyName));
    Json.ObjAddProp(Result, 'addressLine1', Self.stringToJsonValue(Source.AddressLine1));
    if Source.AddressLine2HasValue then
      Json.ObjAddProp(Result, 'addressLine2', Self.stringToJsonValue(Source.AddressLine2));
    if Source.StateHasValue then
      Json.ObjAddProp(Result, 'state', Self.stringToJsonValue(Source.State));
    Json.ObjAddProp(Result, 'city', Self.stringToJsonValue(Source.City));
    Json.ObjAddProp(Result, 'countryCode', Self.stringToJsonValue(Source.CountryCode));
    Json.ObjAddProp(Result, 'postalCode', Self.stringToJsonValue(Source.PostalCode));
    if Source.EmailHasValue then
      Json.ObjAddProp(Result, 'email', Self.stringToJsonValue(Source.Email));
    if Source.PhoneNumberHasValue then
      Json.ObjAddProp(Result, 'phoneNumber', Self.stringToJsonValue(Source.PhoneNumber));
    if Source.VatHasValue then
      Json.ObjAddProp(Result, 'vat', Self.stringToJsonValue(Source.Vat));
    if Source.EoriHasValue then
      Json.ObjAddProp(Result, 'eori', Self.stringToJsonValue(Source.Eori));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TAddressToJson(Source: TAddress): string;
var
  JValue: TJSONValue;
begin
  JValue := TAddressToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TAddressFromJsonValue(Source: TJSONValue): TAddress;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TAddress.Create;
  try
    if Json.ObjContains(Source, 'name', JValue) then
      Result.Name := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'companyName', JValue) then
      Result.CompanyName := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'addressLine1', JValue) then
      Result.AddressLine1 := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'addressLine2', JValue) then
      Result.AddressLine2 := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'state', JValue) then
      Result.State := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'city', JValue) then
      Result.City := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'countryCode', JValue) then
      Result.CountryCode := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'postalCode', JValue) then
      Result.PostalCode := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'email', JValue) then
      Result.Email := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'phoneNumber', JValue) then
      Result.PhoneNumber := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'vat', JValue) then
      Result.Vat := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'eori', JValue) then
      Result.Eori := Self.stringFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TAddressFromJson(Source: string): TAddress;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TAddressFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TServiceOptionsToJsonValue(Source: TServiceOptions): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    if Source.SaturdayDeliveryHasValue then
      Json.ObjAddProp(Result, 'saturdayDelivery', Self.BooleanToJsonValue(Source.SaturdayDelivery));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TServiceOptionsToJson(Source: TServiceOptions): string;
var
  JValue: TJSONValue;
begin
  JValue := TServiceOptionsToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TServiceOptionsFromJsonValue(Source: TJSONValue): TServiceOptions;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TServiceOptions.Create;
  try
    if Json.ObjContains(Source, 'saturdayDelivery', JValue) then
      Result.SaturdayDelivery := Self.BooleanFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TServiceOptionsFromJson(Source: string): TServiceOptions;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TServiceOptionsFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelRequestToJsonValue(Source: TCreateLabelRequest): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'serviceProvider', Self.stringToJsonValue(Source.ServiceProvider));
    Json.ObjAddProp(Result, 'labelSpecification', Self.TLabelSpecificationToJsonValue(Source.LabelSpecification));
    Json.ObjAddProp(Result, 'consignment', Self.TConsignmentToJsonValue(Source.Consignment));
    Json.ObjAddProp(Result, 'packages', Self.TPackageListToJsonValue(Source.Packages));
    if Assigned(Source.Customs) then
      Json.ObjAddProp(Result, 'customs', Self.TCustomsDataToJsonValue(Source.Customs));
    Json.ObjAddProp(Result, 'shipFrom', Self.TAddressToJsonValue(Source.ShipFrom));
    Json.ObjAddProp(Result, 'shipTo', Self.TAddressToJsonValue(Source.ShipTo));
    Json.ObjAddProp(Result, 'serviceType', Self.stringToJsonValue(Source.ServiceType));
    if Assigned(Source.ServiceOptions) then
      Json.ObjAddProp(Result, 'serviceOptions', Self.TServiceOptionsToJsonValue(Source.ServiceOptions));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelRequestToJson(Source: TCreateLabelRequest): string;
var
  JValue: TJSONValue;
begin
  JValue := TCreateLabelRequestToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelRequestFromJsonValue(Source: TJSONValue): TCreateLabelRequest;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCreateLabelRequest.Create;
  try
    if Json.ObjContains(Source, 'serviceProvider', JValue) then
      Result.ServiceProvider := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'labelSpecification', JValue) then
      Result.LabelSpecification := Self.TLabelSpecificationFromJsonValue(JValue);
    if Json.ObjContains(Source, 'consignment', JValue) then
      Result.Consignment := Self.TConsignmentFromJsonValue(JValue);
    if Json.ObjContains(Source, 'packages', JValue) then
      Result.Packages := Self.TPackageListFromJsonValue(JValue);
    if Json.ObjContains(Source, 'customs', JValue) then
      Result.Customs := Self.TCustomsDataFromJsonValue(JValue);
    if Json.ObjContains(Source, 'shipFrom', JValue) then
      Result.ShipFrom := Self.TAddressFromJsonValue(JValue);
    if Json.ObjContains(Source, 'shipTo', JValue) then
      Result.ShipTo := Self.TAddressFromJsonValue(JValue);
    if Json.ObjContains(Source, 'serviceType', JValue) then
      Result.ServiceType := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'serviceOptions', JValue) then
      Result.ServiceOptions := Self.TServiceOptionsFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelRequestFromJson(Source: string): TCreateLabelRequest;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCreateLabelRequestFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemToJsonValue(Source: TCreateLabelResponsePackagesItem): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'documents', Self.stringToJsonValue(Source.Documents));
    Json.ObjAddProp(Result, 'trackingId', Self.stringToJsonValue(Source.TrackingId));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemToJson(Source: TCreateLabelResponsePackagesItem): string;
var
  JValue: TJSONValue;
begin
  JValue := TCreateLabelResponsePackagesItemToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemFromJsonValue(Source: TJSONValue): TCreateLabelResponsePackagesItem;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCreateLabelResponsePackagesItem.Create;
  try
    if Json.ObjContains(Source, 'documents', JValue) then
      Result.Documents := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'trackingId', JValue) then
      Result.TrackingId := Self.stringFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemFromJson(Source: string): TCreateLabelResponsePackagesItem;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCreateLabelResponsePackagesItemFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemListToJsonValue(Source: TCreateLabelResponsePackagesItemList): TJSONValue;
var
  Index: Integer;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateArray;
  try
    for Index := 0 to Source.Count - 1 do
      Json.ArrayAdd(Result, Self.TCreateLabelResponsePackagesItemToJsonValue(Source[Index]));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemListToJson(Source: TCreateLabelResponsePackagesItemList): string;
var
  JValue: TJSONValue;
begin
  JValue := TCreateLabelResponsePackagesItemListToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemListFromJsonValue(Source: TJSONValue): TCreateLabelResponsePackagesItemList;
var
  Index: Integer;
begin
  if not Json.IsArray(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCreateLabelResponsePackagesItemList.Create;
  try
    for Index := 0 to Json.ArrayLength(Source) - 1 do
      Result.Add(Self.TCreateLabelResponsePackagesItemFromJsonValue(Json.ArrayGet(Source, Index)));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelResponsePackagesItemListFromJson(Source: string): TCreateLabelResponsePackagesItemList;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCreateLabelResponsePackagesItemListFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelResponseToJsonValue(Source: TCreateLabelResponse): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'packages', Self.TCreateLabelResponsePackagesItemListToJsonValue(Source.Packages));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelResponseToJson(Source: TCreateLabelResponse): string;
var
  JValue: TJSONValue;
begin
  JValue := TCreateLabelResponseToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TCreateLabelResponseFromJsonValue(Source: TJSONValue): TCreateLabelResponse;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TCreateLabelResponse.Create;
  try
    if Json.ObjContains(Source, 'packages', JValue) then
      Result.Packages := Self.TCreateLabelResponsePackagesItemListFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TCreateLabelResponseFromJson(Source: string): TCreateLabelResponse;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TCreateLabelResponseFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TErrorToJsonValue(Source: TError): TJSONValue;
begin
  if not Assigned(Source) then
  begin
    Result := Json.CreateNull;
    Exit;
  end;
  Result := Json.CreateObject;
  try
    Json.ObjAddProp(Result, 'code', Self.stringToJsonValue(Source.Code));
    Json.ObjAddProp(Result, 'message', Self.stringToJsonValue(Source.Message));
    if Source.DetailsHasValue then
      Json.ObjAddProp(Result, 'details', Self.stringToJsonValue(Source.Details));
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TErrorToJson(Source: TError): string;
var
  JValue: TJSONValue;
begin
  JValue := TErrorToJsonValue(Source);
  try
    Result := JsonValueToJson(JValue);
  finally
    JValue.Free;
  end;
end;

function TJsonConverter.TErrorFromJsonValue(Source: TJSONValue): TError;
var
  JValue: TJSONValue;
begin
  if not Json.IsObject(Source) then
  begin
    Result := nil;
    Exit;
  end;
  Result := TError.Create;
  try
    if Json.ObjContains(Source, 'code', JValue) then
      Result.Code := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'message', JValue) then
      Result.Message := Self.stringFromJsonValue(JValue);
    if Json.ObjContains(Source, 'details', JValue) then
      Result.Details := Self.stringFromJsonValue(JValue);
  except
    Result.Free;
    raise;
  end;
end;

function TJsonConverter.TErrorFromJson(Source: string): TError;
var
  JValue: TJSONValue;
begin
  JValue := JsonToJsonValue(Source);
  try
    Result := TErrorFromJsonValue(JValue);
  finally
    JValue.Free;
  end;
end;

end.
